Loading...
Searching...
No Matches
Sip_refer_to

## Data Structures

struct | sip_refer_to_s
| Structure for Refer-To header. More...

## Macros

#define | sip_refer_to(sip)
| Access a SIP Refer-To header structure sip_refer_to_t from sip_t.
#define | SIP_REFER_TO_INIT()
| Initializer for structure sip_refer_to_t.
#define | SIPTAG_REFER_TO(x)
| Tag list item for pointer to a Refer-To header structure sip_refer_to_t.
#define | SIPTAG_REFER_TO_REF(x)
| Tag list item for reference to a Refer-To header pointer.
#define | SIPTAG_REFER_TO_STR(s)
| Tag list item for string with Refer-To header value.
#define | SIPTAG_REFER_TO_STR_REF(x)
| Tag list item for reference to a Refer-To header string.

## Typedefs

typedef struct sip_refer_to_s | sip_refer_to_t
| @

## Functions

issize_t | sip_refer_to_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Refer-To header.
issize_t | sip_refer_to_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Refer-To header.
sip_refer_to_t * | sip_refer_to_init (sip_refer_to_t x[1])
| Initialize a structure sip_refer_to_t.
int | sip_is_refer_to (sip_header_t const *header)
| Test if header object is instance of sip_refer_to_t.
sip_refer_to_t * | sip_refer_to_dup (su_home_t *home, sip_refer_to_t const *hdr))
| Duplicate a list of Refer-To header header structures sip_refer_to_t.
sip_refer_to_t * | sip_refer_to_copy (su_home_t *home, sip_refer_to_t const *hdr))
| Copy a list of Refer-To header header structures sip_refer_to_t.
sip_refer_to_t * | sip_refer_to_make (su_home_t *home, char const *s))
| Make a Refer-To header structure sip_refer_to_t.
sip_refer_to_t * | sip_refer_to_format (su_home_t *home, char const *fmt,...)))
| Make a Refer-To header from formatting result.

## Variables

msg_hclass_t | sip_refer_to_class []
| Header class for Refer-To header.
tag_typedef_t | siptag_refer_to
| Tag for Refer-To header object.
tag_typedef_t | siptag_refer_to_str
| Tag for string with Refer-To header value.

## Detailed Description

## Macro Definition Documentation

## SIP_REFER_TO_INIT

#define SIP_REFER_TO_INIT | ( |  | ) |

Initializer for structure sip_refer_to_t.

A static sip_refer_to_t structure for Refer-To header must be initialized with the SIP_REFER_TO_INIT() macro. For instance,

sip_refer_to_t sip_refer_to = SIP_REFER_TO_INIT;
SIP_REFER_TO_INIT
#define SIP_REFER_TO_INIT()
Initializer for structure sip_refer_to_t.
Definition sip_protos.h:11334
sip_refer_to_t
struct sip_refer_to_s sip_refer_to_t
@
Definition sip.h:175
sip_refer_to
#define sip_refer_to(sip)
Access a SIP Refer-To header structure sip_refer_to_t from sip_t.
Definition sip_protos.h:11317

## SIPTAG_REFER_TO

#define SIPTAG_REFER_TO | ( |  | x | ) |

Tag list item for pointer to a Refer-To header structure sip_refer_to_t.

The SIPTAG_REFER_TO() macro is used to include a tag item with a pointer to a sip_refer_to_t structure in a tag list.

Parameters

  x | pointer to a sip_refer_to_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_REFER_TO_REF().

## SIPTAG_REFER_TO_STR

#define SIPTAG_REFER_TO_STR | ( |  | s | ) |

Tag list item for string with Refer-To header value.

The SIPTAG_REFER_TO_STR() macro is used to include a tag item with a string containing value of a sip_refer_to_t header in a tag list.

Parameters

  s | pointer to a string containing Refer-To header value, or NULL.

The string in SIPTAG_REFER_TO_STR() can be converted to a sip_refer_to_t header structure by giving the string s has second argument to function sip_refer_to_make().

The corresponding tag taking reference parameter is SIPTAG_REFER_TO_STR_REF().

## Typedef Documentation

## sip_refer_to_t

typedef struct sip_refer_to_s sip_refer_to_t

@

The Refer-To header provides a URI to reference. Its syntax is defined in RFC 3515 section 2.1 as follows:

Refer-To = ("Refer-To" / "r") HCOLON ( name-addr / addr-spec )
*(SEMI generic-param)

The parsed Refer-To header is stored in sip_refer_to_t structure.

The structure sip_refer_to_t contains representation of Refer-To header.

The sip_refer_to_t is defined as follows:

typedef struct sip_refer_to_s
{
sip_common_t r_common[1]; // Common fragment info
sip_error_t *r_next; // Link to next (dummy)
char const r_display; // Display name
url_t r_url[1]; // URI to reference
msg_param_t const *r_params; // List of generic parameters
} sip_refer_to_t;
sip_error_t
msg_error_t sip_error_t
@
Definition sip.h:134
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_refer_to_s
Structure for Refer-To header.
Definition sip.h:592
sip_refer_to_s::r_next
sip_error_t * r_next
Link to next (dummy).
Definition sip.h:594
sip_refer_to_s::r_url
url_t r_url[1]
URI to reference.
Definition sip.h:596
sip_refer_to_s::r_common
sip_common_t r_common[1]
Common fragment info.
Definition sip.h:593
sip_refer_to_s::r_params
msg_param_t const * r_params
List of parameters.
Definition sip.h:597
url_t

## Function Documentation

## sip_is_refer_to()

int sip_is_refer_to | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_refer_to_t.

Check if the header class is an instance of Refer-To header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header refer_to
  0 | (false) otherwise

## sip_refer_to_copy()

sip_refer_to_t * sip_refer_to_copy | ( | su_home_t * | home,
|  | sip_refer_to_t const * | hdr )

inline

Copy a list of Refer-To header header structures sip_refer_to_t.

The function sip_refer_to_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  refer_to = sip_refer_to_copy(home, sip->sip_refer_to);
  sip_refer_to_copy
  sip_refer_to_t * sip_refer_to_copy(su_home_t *home, sip_refer_to_t const *hdr))
  Copy a list of Refer-To header header structures sip_refer_to_t.
  Definition sip_protos.h:11464

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_refer_to_dup()

sip_refer_to_t * sip_refer_to_dup | ( | su_home_t * | home,
|  | sip_refer_to_t const * | hdr )

inline

Duplicate a list of Refer-To header header structures sip_refer_to_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  refer_to = sip_refer_to_dup(home, sip->sip_refer_to);
  sip_refer_to_dup
  sip_refer_to_t * sip_refer_to_dup(su_home_t *home, sip_refer_to_t const *hdr))
  Duplicate a list of Refer-To header header structures sip_refer_to_t.
  Definition sip_protos.h:11421

Returns
  A pointer to the newly duplicated sip_refer_to_t header structure, or NULL upon an error.

## sip_refer_to_format()

sip_refer_to_t * sip_refer_to_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Refer-To header from formatting result.

Make a new sip_refer_to_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_refer_to_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_refer_to_init()

sip_refer_to_t * sip_refer_to_init | ( | sip_refer_to_t | x[1] | ) |

inline

Initialize a structure sip_refer_to_t.

An sip_refer_to_t structure for Refer-To header can be initialized with the sip_refer_to_init() function/macro. For instance,

sip_refer_to_t sip_refer_to;
sip_refer_to_init(&sip_refer_to);
sip_refer_to_init
sip_refer_to_t * sip_refer_to_init(sip_refer_to_t x[1])
Initialize a structure sip_refer_to_t.
Definition sip_protos.h:11352

## sip_refer_to_make()

sip_refer_to_t * sip_refer_to_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Refer-To header structure sip_refer_to_t.

The function sip_refer_to_make() makes a new sip_refer_to_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_refer_to_t header structure, or NULL upon an error.

## Variable Documentation

## sip_refer_to_class

msg_hclass_t sip_refer_to_class[]

extern

Header class for Refer-To header.

The header class sip_refer_to_class defines how a SIP Refer-To header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_refer_to_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.